using System;
using System.IO;
using System.Drawing;
using System.Windows.Forms;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using Direct3D=Microsoft.DirectX.Direct3D;
using Microsoft.Samples.DirectX.UtilityToolkit;

namespace Demo
{
	/// <summary>
	/// Summary description for Object.
	/// </summary>
	public class Object
	{

		
		Mesh mesh = null; // Our mesh object in sysmem
		Direct3D.Material[] meshMaterials; // Materials for our mesh
		Texture[] meshTextures; // Textures for our mesh
		//PresentParameters presentParams = new PresentParameters();

		public Object(Device dev)
		{
			ExtendedMaterial[] materials = null;

			// Set the directory up two to load the right data (since the default build location is bin\debug or bin\release
			//Directory.SetCurrentDirectory(Application.StartupPath +  @"\..\..\");

			

			// Turn on the zbuffer
			dev.RenderState.ZBufferEnable = true;

			// Turn on ambient lighting 
			dev.RenderState.Ambient = System.Drawing.Color.White;
			// Load the mesh from the specified file
			mesh = Mesh.FromFile("tiger.x", MeshFlags.SystemMemory, dev, out materials);

            
			if (meshTextures == null)
			{
				// We need to extract the material properties and texture names 
				meshTextures  = new Texture[materials.Length];
				meshMaterials = new Direct3D.Material[materials.Length];
				for( int i=0; i<materials.Length; i++ )
				{
					meshMaterials[i] = materials[i].Material3D;
					// Set the ambient color for the material (D3DX does not do this)
					meshMaterials[i].Ambient = meshMaterials[i].Diffuse;
     
					// Create the texture
					meshTextures[i] = TextureLoader.FromFile(dev, materials[i].TextureFilename);
				}
			}
		}

		public void Draw(Device RenderingDevice)
		{
			System.Diagnostics.Debug.WriteLine("myobj drawn");
			for( int i=0; i<meshMaterials.Length; i++ )
			{
				// Set the material and texture for this subset
				RenderingDevice.Material = meshMaterials[i];
				RenderingDevice.SetTexture(0, meshTextures[i]);
        
				// Draw the mesh subset
				mesh.DrawSubset(i);
			}

			
		}
	}


}
